#address		NEXT_RAM		0x30000			; RAM starting address
#address		NEXT_ROM		0x400				; start storing constants at 0x400
#address		NEXT_PC		NEXT_ROM+0x1000	; allow an area of 0x1000 for constants

#address		NEXT_RAM							; set the Address Pointer to NEXT_RAM (0x30000)
Value_1:		#alloc.1							; create a 1-byte variable with the name Value_1
Value_2:		#alloc.4							; create a 4-byte variable with the name Value_2
Label_Name_Longer_Than_16_Characters:
;  NEXT_RAM now is 0x30005

#address	NEXT_ROM								; set the Address Pointer to NEXT_ROM (0x400)
Const_1:			#alloc.2		0x1234		; create a 2byte constant
Const_Values:	#alloc.1		1,2,3,4,5	; create a table of constants with 5 bytes
; NEXT_ROM now is 0x407
;#allocb.8		1000								; alloc large ROM area to cause error

#address	NEXT_PC								; set the Address Pointer to NEXT_PC (0x1400)
#vector	VECTOR_START						; set startup vector to the value of  NEXT_PC
Program_Start:									    ; label of the start of the program
#allocb.1	0x123							        ; force allocation of 0x123 bytes
#allocb.2	25                                     ; should start on even address
; put some code here  assume the code size is 0x1234 bytes
; NEXT_PC is now 0x2634

; set up some variables for Function_1
#address	NEXT_RAM							; set the Address Pointer to NEXT_RAM (0x30005)
Block_1:	#alloc.1		10					; allocate 10 elements of 1 byte each
Block_2:	#alloc.8		32					; allocate 32 elements of 8 bytes each
;  NEXT_RAM now is 0x30005 + 10. + (32*8): 0x30005 + 0x000A + 0x0100 = 0x3010A

#address	NEXT_PC								; set the Address Pointer to NEXT_PC (0x2634)
Fun_1_Consts:	#alloc.4		54321, 12345, 98765, 56789	; some constants for Function_1
; NEXT_PC is now 0x2634 + 16. : 0x2644
Function_1:
; put some code here

; ISR for serial port 1 transmitter
#vector	VECTOR_SP1TX						; use NEXT_PC as the value for <address of ISR>
SP1TxISR:
; code for the transmit ISR

#vector VECTOR_RTC
	reti
